## download data
#download.file(url =, destfiel =) permet de télécharger un fichier par son URL
#l'argument destfile précise la destination du fichier
download.file(url = "https://ndownloader.figshare.com/files/2292169",
              destfile = "data/portal_data_joined.csv")

## error! no data2 directory
download.file(url = "https://ndownloader.figshare.com/files/2292169",
             destfile = "data2/portal_data_joined.csv")

## import csv file into R (read.csv())
## and create new variable called survey
survey <- read.csv("data/portal_data_joined.csv")

## a data.frame
class(survey)

## explore the data.frame
#ncol() pour le nombre de colonnes = variables
ncol(survey)
#names() pour le nom des variables = colonnes
names(survey)
#nrow() pour le nombre de lignes = observations du data.frame
nrow(survey)
#dim() pour la dimension du data.frame : première valeure = nrow, seconde = ncol
dim(survey)

#str() (structure) pour afficher le data.frame en montrant la structure de chaque colonne individuelle
str(survey)

#head() affiche les 6 premières observations
head(survey)
#tail() affiche les 6 dernières observations
tail(survey)

#View() affiche le data.frame en tableur (comme dans Excel)
View(survey)

#Il est toutefois impossible de regarder un très grand jeu de données, surtout pour raisonner dessus

## subsetting [
#[ligne = observation, colonne = variable]
survey[10, 3]
#Ainsi, 3ème variable = jour donc le jour où la 10ème observation a été collectée était le 11
survey[1, 1]
survey[29561, 12]

#un blanc correspond à 'tout'
survey[, 1]
#toutes les observations de la première variable
str(survey[, 1])

y <- survey[, 4]
length(y)
nrow(survey)
table(y)

survey[1, ]
class(survey[1, ])
#la classe est un data.frame de dimension 1 x 13 (une seule observation)
dim(survey[1, ])

head(survey)
#Autre manière de considérer les 6 premières observations
survey[1:6, ]

#obtenir un data.frame pour les 10 premières observations, et pour 4 variables
survey[1:10, c(2, 3, 4, 13)]

#pour la 1ère obs, toutes les variables sauf 1 et 13 : -
survey[1, -c(1, 13)]
#tout sauf la première observation et les variables 1 et 13
dim(survey[-1, -c(1, 13)])

#3 mêmes résultats
head(survey)
survey[1:6, ]
survey[-(7:34786), ]

survey[, 4]

#On peut faire la même chose en utilisant le nom des colonnes selon plusieurs syntaxes
# = extraction de colonne
survey[, "year"] ## donne un vecteur-colonne
survey$year      ## vecteur-colonne
survey[["year"]] ## vecteur-colonne

survey["year"]   ## nouveau data.frame de dimension 34786 x 1
dim(survey["year"])


## Exercice (cours en fin de 4.4)

survey_200 <- survey[200, ]
survey_200

nrow(survey)

survey[34786, ]
tail(survey)

survey_last <- survey[nrow(survey), ]
survey_last
#première alternative préférable car fonctionne toujours peu importe le jeu de données

nrow(survey)
nrow(survey)/2

survey_middle <- survey[nrow(survey)/2, ]
survey_middle

head(survey)
survey[-(7:34786), ]
survey[-( 7:nrow(survey) ), ]


names(survey)
colnames(survey)
#2 manières d'avoir le nom des colonnes
rownames(survey)
#nom des lignes = indices


survey$weight #Extraction de la colonne wieght du data.frame survey
#Il y a des NA : les observations manquantes sont données par is.na()
is.na(survey$weight) ## logiquement : length == nrow(survey)
sel_w <- is.na(survey$weight)

table(sel_w)

length(sel_w) == nrow(survey)

table(sel_w)

nrow(survey[sel_w, ])
nrow(survey[!sel_w, ])

View(survey[sel_w, ])
View(survey[!sel_w, ])

survey_with_weigth <- survey[!sel_w, ] #Nouveau data.frame seulement avec les observations avec un poids
#C'est-à-dire prendre la négation (!) pour avoir les FALSE (qui étaient TRUE)
head(survey_with_weigth)
dim(survey_with_weigth)

table(is.na(survey_with_weigth$weight))

survey_noNA <- na.omit(survey) #pour éliminer ttes obsv avec 1+ NA
dim(survey_noNA)

## import: 
## - read.csv() Lire un fichier csv
## - read.csv2() Pour les données séparées par ;
## - read.delim() Pour les données séparées par tabulation
?read.table #A lire
## export
write.csv(survey_noNA, file = "data/survey_noNA.csv") #write.csv() prend un csv pour l'écrire dans un nouveau csv
#premier argument = data.frame, second argument = destination

## save() and load()
## saveRDS() and readRDS() : pour écrire les variables directement en structure binaire sur disque sur R

saveRDS(survey_noNA, file = "data/survey_noNA.rds")
rm(survey_noNA)
x <- readRDS("data/survey_noNA.rds")



